/*
 * Copyright (C) Christof Musik, bitbone AG
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef OIDMAP_H
#define OIDMAP_H

class OIDMap {
    public:
	OIDMap(void);
	OIDMap(QString);
	~OIDMap(void);
	QString getOid(QString);
	int getUnit(QString);
	QStringList getKeys(void);
	QMap<QString,QString> getMapOID(void);
	QMap<QString,int> getMapUnit(void);
	void openFile();
	void openFile(QString);
	bool add(QString, QString);
	void erase(QString);
	void setMap(QMap<QString,QString>);
	void setMap(QMap<QString,int> newmap);
	void save(void);
	void setMapFilename(QString);
	void setMapFile(QString);
	QString getMapFilename();
	bool nameExists(QString);

    private:
	QMap<QString,QString> mapoid;
	QMap<QString,int> mapunit;
	QString mapfilename;
};
#endif
