/*
 * Copyright (C) Christof Musik, bitbone AG
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <qcolordialog.h>
#include <qfiledialog.h>
#include <qfontdialog.h>
#include <iostream>


void prefdialog::fgcolor()
{
    QColor f = QColorDialog::getColor(fg);
    if (f.isValid()) {
	    fg = f;
	    btnfg->setPaletteBackgroundColor(f);
    }
}


void prefdialog::bgcolor()
{
    QColor b = QColorDialog::getColor(bg);
    if (b.isValid()) {
	    bg = b;
	    btnbg->setPaletteBackgroundColor(b);
    }
}

void prefdialog::graphcolor()
{
    QColor b = QColorDialog::getColor(graph);
    if (b.isValid()) {
	    graph = b;
	    btngraph->setPaletteBackgroundColor(b);
    }
}

void prefdialog::initColors(QColor b, QColor f, QColor g)
{
    bg = b;    
    fg = f;
    graph = g;
    btnbg->setPaletteBackgroundColor(bg);
    btnfg->setPaletteBackgroundColor(fg);
    btngraph->setPaletteBackgroundColor(graph);
}

void prefdialog::initFont(QFont f) {
    tlFont->setText(f.family()+" "+QString::number(f.pointSize()));
    font = f;
}

void prefdialog::addhost()
{
    if (line_hosts->text() != "") {
	list_hosts->insertItem(line_hosts->text());
	line_hosts->clear();
    }
}

void prefdialog::deletehost()
{
    list_hosts->takeItem(list_hosts->selectedItem());
}

void prefdialog::initHosts( QStringList slist )
{
    list_hosts->insertStringList(slist);
}

void prefdialog::checkdeletebtn()
{
        if (list_hosts->selectedItem() == NULL) {
	btndelete->setEnabled(false);
    } else {
	btndelete->setEnabled(true);
    }
}

QStringList prefdialog::getKnownHosts()
{
    QStringList list;

    for (int i = 0; i < list_hosts->numRows(); i++) {
	list.append(list_hosts->item(i)->text());
    }
    return list;
}


void prefdialog::checkaddbtn()
{
    if  (line_hosts->text() != "")  {
	btnadd->setEnabled(true);
    } else {
	btnadd->setEnabled(false);
    }
}


void prefdialog::checkmovebtn()
{
    if (list_hosts->selectedItem() == NULL) {
	btnup->setEnabled(false);
	btndown->setEnabled(false);
    } else if (list_hosts->currentItem() == 0) {
	btnup->setEnabled(false);
	btndown->setEnabled(true);
    } else if (list_hosts->currentItem() == list_hosts->numRows()-1) {
	btnup->setEnabled(true);
	btndown->setEnabled(false);
    } else {
	btnup->setEnabled(true);
	btndown->setEnabled(true);
    }
}

/*!
 * Moves an item in list_hosts up
 */
void prefdialog::hostmoveup()
{
    if (list_hosts->currentItem() > 0)  {
	QString selected = list_hosts->selectedItem()->text();
	QString above = list_hosts->selectedItem()->prev()->text();
	int i = list_hosts->currentItem();
	list_hosts->changeItem(above, i);
	list_hosts->changeItem(selected, i-1);
    }
}


/*!
 * Moves an item in list_hosts down
 */
void prefdialog::hostmovedown()
{
   if (list_hosts->currentItem() < list_hosts->numRows()-1) {
	QString selected = list_hosts->selectedItem()->text();
	QString above = list_hosts->selectedItem()->next()->text();
	int i = list_hosts->currentItem();
	list_hosts->changeItem(above, i);
	list_hosts->changeItem(selected, i+1);
    }
}

void prefdialog::getFont() {
    QFont f = QFontDialog::getFont(0, font);
    initFont(f);
}
